
This is the SC plugin development branch !!

At the current state this is more or less a technology preview.
The code is of alpha quality, but we release it to increase the test basis.

Using it in a production environment is not recommended!
There are some limitations in using it. See further down in this file.

Feel free to put your bugreports, suggestions and/or wishes to the 4free or DVBN
board. A bugreports should at least include the console log.

The main development goal for this branch is a full-featured SC implementation
without the needs to patch VDR. Recent changes in the new VDR development branch
opened a possibility for that.

The plugin captures the DVB devices in an early startup stage of VDR startup
(before VDR itself has got access to them) and makes VDR believe that there is
another CAM connected to the device. This CAM is emulated from the plugin by
providing a cut-down EN50221 interface for communication with the VDR core. From
VDR views there is no difference between a real hardware CAM and the emulated
CAM. 

Changes in installation/operation:
----------------------------------

You must use VDR 1.5.0. Newer version might be supported, but this will depend
on how much the VDR core changes.

You MUST NOT apply any vdr-sc and/or ffdecsa/softcsa patches to the VDR core.

Using openssl 0.9.7 or newer is mandatory now. You should compile your openssl
package with AES and IDEA options, as support for openssl without these options
will be removed in the near future.

FFdecsa functionality is include into the plugin (See file README.FFdecsa for
further information e.g. make options). Note that some budget card drivers
provide a CA device too. This might make VDR and the plugin detect the card as a
full-featured card, thus disabling FFdecsa. You should use commandline option -B
to force detection as a budget card in such a case.

There is no longer a possibility to limit the number of concurrent streams. VDR
itself never had any limit in concurrent streams (neither FTA nor encrypted) and
as now the VDR core control more aspects of operation, there is no way to
enforce a limit (beside disabling concurrent encrypted streams at all).

The SC.ConcurrentFF setting has been changed to a boolean flag to allows or
disallow concurrent streams on full-featured DVB cards. Note that toggling the
flag from off to on will take effect at the next switch to a encrypted channel,
while toggling the flag from on to off needs a VDR restart to come into effect.
The SC.ConcurrentSoft setting has been removed.

A real hardware CAM is normaly pretty sure about which CAIDs it supports. With
SC the situation is a bit different. There is support for a wide range of
encryption system and cardclients. This results in a huge number of supported
CAIDs, but for most of them it's uncertain if SC will actualy be able to decrypt
a channel for them.
On the other hand VDR limits the number of supported CAIDs to 16 for each CAM
slot and to 8 CAM slots for a CI adapter. So SC is only able to support up to
128 CAIDs out of the 65536 possible.

To reduce the number of CAIDs SC has to deal with, you should obey some rules:
-Remove all libsc-* files for encryption system which you don't intend to use
 (e.g. SHL seems pretty useless nowadays).
-When using a cardclient, be as precise as possible with the CAID/MASK values in
 the cardclient.conf file. Using wide open 0000/0000 is deprecated.
-Add CAIDs which you cannot use due to lack of keys to the SC.Ignore setting.

On startup and at regular intervals the plugin scans the channels list and
builds chains of CAIDs for them. The CAID chains are assigned to the simulated
CAM slots. 
Due to limitations in VDR core, you cannot concurrently watch/record channels
with CAIDs assigned to different CAM slots.
While building the CAID chains the plugin takes care that all CAIDs for a given
channel are put to the same chain. This may lead to the situation that a CAID is
assigned to multiple CAM slots, reducing the total number of supported CAIDs.

Finally: Have fun!!
